_G[gTable] = {};

local aTmpVal   = gTable;
cm.SetupTable(_G[aTmpVal]);

-- Called on Init
_G[gTable].OnInit = function(pObj)
	pObj.mState = 0;
end


-- Called after data being loaded from disk
_G[gTable].OnLoad = function(pObj)
end


-- Called on a update
_G[gTable].OnUpdate = function(pObj)

end


-- Called on a succesful click
_G[gTable].OnClick =  function(pObj, pName, pActorObj, pPolyNum, pX, pY)

	pObj.mDiscovered = true;
	local aState     = pObj.mState;

	if pName == "" then

   	if aState == 1 then
         if not cm.SpawnObject(pObj, 0, pObj.mSmPos, "SpawnObject") then
            return true;
         end

         pObj:StartFadeRects(PhFadeAnotherTimeLong);
   		pObj.mState		 = aState + 1;
   		pObj.mCurCell   = pObj.mCurCell + 1;
   		cm.DisableObject(pObj);
   		IcPlaySample("PH_SFX_OBJ_PICKUP");
   		return true;
   	end

   	if pObj.mCsData:IfExistsString("LockedInfo") then
         cm.GetShowInfo(pObj, "LockedInfo", "LockedInfoTime");
      else
         cm.ShowInfo(pObj, "It appears to be locked");
      end

   	return true;

   -- The chest is unlocked
	elseif pName == pObj.mCsData:GetString("KeyObject") then
	
      if not cm.GetGlobalBoolIndirect(pObj, "ActivatorFlag1") then
         pObj.mPdata:UnMouseObject();
         cm.GetShowInfo(pObj, "InfoStr1", "InfoTime1");
         IcPlaySample("PH_SFX_DOES_NOT_WORK");
         return true;
      end

      if aState == 0 then

         pObj:StartFadeRects(PhFadeAnotherTimeLong);
   		pObj.mState		  = aState + 1;
   		pObj.mCurCell	  = pObj.mCurCell + 1;

   		pObj:SetActive(0, pPolyNum, false);
   		pObj:SetActive(0, pPolyNum + 1, true);
   		pObj:StopParticleEmission(false);

   		_G[pActorObj.mScriptTag].OnUse(pActorObj, pObj);
   		return true;
		end

		cm.ObjDoesNotWork(pObj);
		return false;

	else
		cm.ObjDoesNotWork(pObj);
		return false;
	end

	return false;
end



-- Called on draw
_G[gTable].OnDraw =  function(pObj, pG)

	local aRpos = pObj.mSmPos;
	local aImg  = IcImageWrap(pObj.mSmallImage);
	assert(aImg);
	local aRect = aImg:GetCelRect(pObj.mCurCell);
	pG:DrawImage(aImg:GetImage(), aRpos.x, aRpos.y, aRect);

end


-- Zooms Out
_G[gTable].NormalSize = cm.ZoomOut;


-- Zooms In
_G[gTable].GetBigger = cm.ZoomIn;


